Imports System.Math

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileSave As System.Windows.Forms.MenuItem
    Friend WithEvents dlgOpenPicture As System.Windows.Forms.OpenFileDialog
    Friend WithEvents dlgSavePicture As System.Windows.Forms.SaveFileDialog
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuDataReset As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        Me.mnuFileSave = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.mnuDataReset = New System.Windows.Forms.MenuItem
        Me.dlgOpenPicture = New System.Windows.Forms.OpenFileDialog
        Me.dlgSavePicture = New System.Windows.Forms.SaveFileDialog
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.MenuItem2})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen, Me.mnuFileSave})
        Me.MenuItem1.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open"
        '
        'mnuFileSave
        '
        Me.mnuFileSave.Index = 1
        Me.mnuFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.mnuFileSave.Text = "&Save"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 1
        Me.MenuItem2.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuDataReset})
        Me.MenuItem2.Text = "&Data"
        '
        'mnuDataReset
        '
        Me.mnuDataReset.Index = 0
        Me.mnuDataReset.Shortcut = System.Windows.Forms.Shortcut.CtrlR
        Me.mnuDataReset.Text = "&Reset"
        '
        'dlgOpenPicture
        '
        Me.dlgOpenPicture.Filter = "Image Files|*.bmp;*.gif;*.jpg;*.jpe*;*.png;*.tif|All Files (*.*)|*.*"
        '
        'dlgSavePicture
        '
        Me.dlgSavePicture.Filter = "Image Files|*.bmp;*.gif;*.jpg;*.jpe*;*.png;*.tif|All Files (*.*)|*.*"
        '
        'picCanvas
        '
        Me.picCanvas.Dock = System.Windows.Forms.DockStyle.Fill
        Me.picCanvas.Location = New System.Drawing.Point(0, 0)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(292, 273)
        Me.picCanvas.TabIndex = 0
        Me.picCanvas.TabStop = False
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.picCanvas)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "ImagePixelator"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_OriginalBitmap As Bitmap
    Private m_CurrentBitmap As Bitmap
    Private m_TempBitmap As Bitmap
    Private m_Gr As Graphics
    Private m_Pen As Pen

    Private m_SelectingArea As Boolean
    Private m_X1 As Integer
    Private m_Y1 As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Set the initial directory for dialogs.
        Dim init_dir As String = Application.StartupPath
        If init_dir.EndsWith("\bin") Then init_dir = init_dir.Substring(0, init_dir.Length - 4)
        dlgOpenPicture.InitialDirectory = init_dir
        dlgSavePicture.InitialDirectory = init_dir
    End Sub

    ' Let the user open an image file.
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If dlgOpenPicture.ShowDialog() = DialogResult.OK Then
            Try
                Dim bm As New Bitmap(dlgOpenPicture.FileName)
                m_OriginalBitmap = New Bitmap(bm)
                m_CurrentBitmap = New Bitmap(bm)
                bm.Dispose()
                picCanvas.Image = m_CurrentBitmap
                dlgSavePicture.InitialDirectory = dlgOpenPicture.FileName

                ' Make the form big enough.
                Me.ClientSize = New Size(m_OriginalBitmap.Width, m_OriginalBitmap.Height)
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    ' Save the current image.
    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click
        If dlgSavePicture.ShowDialog() = DialogResult.OK Then
            Try
                m_CurrentBitmap.Save(dlgSavePicture.FileName)
                dlgOpenPicture.InitialDirectory = dlgSavePicture.FileName
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    ' Restore the original image.
    Private Sub mnuDataReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuDataReset.Click
        If m_OriginalBitmap Is Nothing Then Exit Sub
        m_CurrentBitmap = New Bitmap(m_OriginalBitmap)
        picCanvas.Image = m_CurrentBitmap
    End Sub

    ' Start selecting an area.
    Private Sub picCanvas_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseDown
        ' Make sure we have a picture loaded.
        If m_OriginalBitmap Is Nothing Then Exit Sub

        mnuDataReset.Enabled = False
        m_SelectingArea = True
        m_X1 = e.X
        m_Y1 = e.Y

        ' Make a copy of the current bitmap 
        'and prepare to draw.
        m_TempBitmap = New Bitmap(m_CurrentBitmap)
        m_Gr = Graphics.FromImage(m_TempBitmap)
        m_Pen = New Pen(Color.Yellow)
        m_Pen.DashStyle = Drawing2D.DashStyle.Dash
    End Sub

    ' Continue selecting the area.
    Private Sub picCanvas_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseMove
        If Not m_SelectingArea Then Exit Sub

        ' Start with the current image.
        m_Gr.DrawImage(m_CurrentBitmap, 0, 0)

        ' Draw the new selection box.
        m_Gr.DrawRectangle(m_Pen, _
            Min(m_X1, e.X), _
            Min(m_Y1, e.Y), _
            Abs(e.X - m_X1), _
            Abs(e.Y - m_Y1))

        ' Display the result.
        picCanvas.Image = m_TempBitmap
    End Sub

    ' Finish selecting the area.
    Private Sub picCanvas_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseUp
        If Not m_SelectingArea Then Exit Sub
        m_SelectingArea = False

        ' Make sure this point is on the picture.
        Dim x As Integer = e.X
        If x < 0 Then x = 0
        If x > m_OriginalBitmap.Width - 1 Then x = m_OriginalBitmap.Width - 1

        Dim y As Integer = e.Y
        If y < 0 Then y = 0
        If y > m_OriginalBitmap.Height - 1 Then y = m_OriginalBitmap.Height - 1

        ' Pixelate the selected area.
        PixelateArea( _
            Min(m_X1, x), _
            Min(m_Y1, y), _
            Abs(x - m_X1), _
            Abs(y - m_Y1))

        ' We're done drawing for now.
        m_Pen.Dispose()
        m_Gr.Dispose()
        m_TempBitmap.Dispose()

        m_Pen = Nothing
        m_Gr = Nothing
        m_TempBitmap = Nothing

        mnuDataReset.Enabled = True
    End Sub

    ' Pixelate the area.
    Private Sub PixelateArea(ByVal x As Integer, ByVal y As Integer, ByVal wid As Integer, ByVal hgt As Integer)
        Const cell_wid As Integer = 20
        Const cell_hgt As Integer = 10

        ' Start with the current image.
        m_Gr.DrawImage(m_CurrentBitmap, 0, 0)

        ' Make x and y multiples of cell_wid/cell_hgt
        ' from the origin.
        Dim new_x As Integer = cell_wid * Int(x \ cell_wid)
        Dim new_y As Integer = cell_hgt * Int(y \ cell_hgt)

        ' Pixelate the selected area.
        For x1 As Integer = new_x To x + wid Step cell_wid
            For y1 As Integer = new_y To y + hgt Step cell_hgt
                AverageRectangle(x1, y1, cell_wid, cell_hgt)
            Next y1
        Next x1

        ' Set the current bitmap to the result.
        m_CurrentBitmap = New Bitmap(m_TempBitmap)

        ' Display the result.
        picCanvas.Image = m_CurrentBitmap
    End Sub

    ' Fill this rectangle with the average of its pixel values.
    Private Sub AverageRectangle(ByVal x As Integer, ByVal y As Integer, ByVal wid As Integer, ByVal hgt As Integer)
        ' Make sure we don't exceed the image's bounds.
        If x < 0 Then x = 0
        If x + wid >= m_OriginalBitmap.Width Then
            wid = m_OriginalBitmap.Width - x - 1
        End If
        If wid <= 0 Then Exit Sub

        If y < 0 Then y = 0
        If y + hgt >= m_OriginalBitmap.Height Then
            hgt = m_OriginalBitmap.Height - y - 1
        End If
        If hgt <= 0 Then Exit Sub

        ' Get the total red, green, and blue values.
        Dim clr As Color
        Dim r As Integer
        Dim g As Integer
        Dim b As Integer
        For i As Integer = 0 To hgt - 1
            For j As Integer = 0 To wid - 1
                clr = m_CurrentBitmap.GetPixel(x + j, y + i)
                r += clr.R
                g += clr.G
                b += clr.B
            Next j
        Next i

        ' Calculate the averages.
        r \= wid * hgt
        g \= wid * hgt
        b \= wid * hgt

        ' Set the pixel values.
        Dim ave_brush As New SolidBrush(Color.FromArgb(255, r, g, b))
        m_Gr.FillRectangle(ave_brush, x, y, wid, hgt)
        ave_brush.Dispose()
    End Sub
End Class
